---
title: 'ReferenceError: assignment to undeclared variable "x"'
slug: Web/JavaScript/Reference/Errors/Undeclared_var
tags:
  - Error
  - Errors
  - JavaScript
  - ReferenceError
  - Strict Mode
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>-only exception "Assignment to undeclated variable" occurs when the value has been assigned to an undeclared variable.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">ReferenceError: assignment to undeclared variable "x" (Firefox)
ReferenceError: "x" is not defined (Chrome)
ReferenceError: Variable undefined in strict mode (Edge)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("ReferenceError")}} warning in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> only.</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>A value has been assigned to an undeclared variable. In other words, there was an assignment without the <code>var</code> keyword. There are some differences between declared and undeclared variables, which might lead to unexpected results and that's why JavaScript presents an error in strict mode.</p>

<p>Three things to note about declared and undeclared variables:</p>

<ul>
 <li>Declared variables are constrained in the execution context in which they are declared. Undeclared variables are always global.</li>
 <li>Declared variables are created before any code is executed. Undeclared variables do not exist until the code assigning to them is executed.</li>
 <li>Declared variables are a non-configurable property of their execution context (function or global). Undeclared variables are configurable (e.g. can be deleted).</li>
</ul>

<p>For more details and examples, see the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/var">var</a></code> reference page.</p>

<p>Errors about undeclared variable assignments occur in <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode code</a> only. In non-strict code, they are silently ignored.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_cases">Invalid cases</h3>

<p>In this case, the variable "bar" is an undeclared variable.</p>

<pre class="brush: js example-bad">function foo() {
  'use strict';
  bar = true;
}
foo(); // ReferenceError: assignment to undeclared variable bar
</pre>

<h3 id="Valid_cases">Valid cases</h3>

<p>To make "bar" a declared variable, you can add the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/var">var</a></code> keyword in front of it.</p>

<pre class="brush: js example-good">function foo() {
  'use strict';
  var bar = true;
}
foo();</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">Strict mode</a></li>
</ul>
